
#define STRICT

//  

#define _USE_MATH_DEFINES

#pragma comment(lib, "d3d9.lib")
#pragma comment(lib, "d3dx9.lib")
#pragma comment(lib, "winmm.lib")
#pragma comment(lib, "dsound.lib")
#pragma comment(lib, "dxguid.lib")
#pragma comment(lib, "d3dxof.lib")
#pragma comment(lib, "dinput8.lib")
#pragma comment(lib, "DXGI.lib")
//#pragma comment(lib, "tokamak.lib")

#include<Windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <io.h>
#include <mmsystem.h>
#include <cmath>
#include<d3d9.h>
#include<d3dx9.h>
#include <dinput.h>
#include <dsound.h>
#include <d3dx9mesh.h>
#include <d3dx9core.h>
#include <DXGI.h>
//#include <tokamak.h>

#include "rmxftmpl.h"
#include "rmxfguid.h"
#include "dxfile.h"

#define KEYDOWN(name, key)(name[key]&0x80)
#define MouseButton(x) ((dims.rgbButtons[x] & 0x80) ? TRUE : FALSE)
#define ReleaseCOM(x) if(x) { x->Release(); x = NULL; }

HWND hwnd;


LPDIRECT3D9 pD3D=NULL;
LPDIRECT3DDEVICE9 p3Ddev=NULL;

D3DCAPS9 caps;

int iWidth=GetSystemMetrics(SM_CXSCREEN);
int iHeight=GetSystemMetrics(SM_CYSCREEN);
int vp=0;

//DirectInput      
LPDIRECTINPUT8 pDI=NULL;
LPDIRECTINPUTDEVICE8 pMouse=NULL, pKeyboard=NULL;
DIMOUSESTATE dims;
char keyb[256];

//    FPS
DWORD FrameCnt;
float TimeElapsed;
float FPS;
float oldTime;
//=============================

float YawX;
float YawY;
float PitchX;
float PitchD;

float angleYaw;
float anglePitch;

float angleYaw1;
float anglePitch1;

float CameraX = 0.0f;
float CameraY = 0.0f;
float CameraZ = 10.0f;

/////////////////////////////////////////////////////////////////
//          .

LPD3DXMESH pMesh[50];
LPD3DXBUFFER pMeshBuffer[50];
D3DMATERIAL9* pMeshMaterial[50];
LPDIRECT3DTEXTURE9* pMeshTextura[50];
DWORD dwMeshNumber[50];

///=================================

D3DPRESENT_PARAMETERS d3dpp;

//===========================================

//     

LPD3DXMATRIXSTACK g_matrixStack = NULL;		//   
float g_fBallPosX    = 0.0f;				//     X
float g_fDestPosX    = 0.0f;				//    X,    

//================================================================================
//////////////////////////////////////////////////////////////////////////////////

LRESULT CALLBACK MainWinProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam);

HRESULT Initial3D(HWND hwnd, DWORD, DWORD, BOOL bFullScreen);
void Rendering3D();
void DeleteDirect3D();

HRESULT InitialInput();

void Camera();

//      
void R_S_T_Matrix(float MatX, float MatY, float MatTx, float MatTy, float MatTz,
			   float Sx, float Sy, float Sz);


HRESULT InitialMeshObject(int mesh, LPCTSTR pFilename, LPCTSTR pSrcFile);
void RenderMeshObject(int mesh);

void LightPoint();//  

//===============================================================================

int WINAPI WinMain(HINSTANCE hinstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, 
				   int nCmdShow)
{
 HWND hwnd;
 MSG msg;
 WNDCLASSEX wc;


 CoInitialize(0);

 wc.cbSize=sizeof(WNDCLASSEX);
 wc.style=CS_DBLCLKS|CS_OWNDC|CS_HREDRAW|CS_VREDRAW;
 wc.lpfnWndProc=MainWinProc;
 wc.cbClsExtra=0;
 wc.cbWndExtra=0;
 wc.hInstance=hinstance;
 wc.hIcon=LoadIcon(hinstance, "ProgGame.ico");
 wc.hIconSm=LoadIcon(hinstance, "ProgGame.ico");
 wc.hCursor=LoadCursor(NULL, IDC_ARROW);
 wc.hbrBackground=(HBRUSH)GetStockObject(GRAY_BRUSH);
 wc.lpszMenuName=NULL;
 wc.lpszClassName="WINDOWSCLASS";

 RegisterClassEx(&wc);

 hwnd=CreateWindowEx(WS_EX_CLIENTEDGE, "WINDOWSCLASS", "BumBum3D", WS_OVERLAPPEDWINDOW, 0, 0, 
	       iWidth, iHeight, NULL, NULL, hinstance, NULL);

 Initial3D(hwnd, iWidth, iHeight, TRUE);

 
 InitialMeshObject(0, "Object\\WarOfMachinesObject.x", "");

 InitialMeshObject(1, "Object\\WarOfMachinesObject_1.x", "");

 InitialMeshObject(2, "Object\\WarOfMachinesLand.x", "");

//InitialText
//for(int i = 0; i < 16; i++){TextT(i, 16);}
 
//  InitialSound();

 HRESULT hr;
 hr=DirectInput8Create(hinstance, DIRECTINPUT_VERSION, IID_IDirectInput8, (void**)&pDI, NULL);
 if(FAILED(hr))
 {
	 MessageBox(0, "InitialInput, DirectInput8Create Error", "Error", 0);
	 return FALSE;
 }

 InitialInput();

 ShowCursor(FALSE);
 ShowWindow(hwnd, SW_SHOWDEFAULT);
 UpdateWindow(hwnd);
 SetFocus(hwnd);	
 SetForegroundWindow(hwnd);

//if(FAILED(DirectSoundCreate8(NULL, &pDiSound, NULL))) {
//    MessageBox(NULL, "Unable to create DirectSound object", "Error", MB_OK);
//    return 0;
//  }
 

// if(FAILED(CoCreateInstance(CLSID_FilterGraph, NULL, CLSCTX_INPROC_SERVER, IID_IGraphBuilder,
//	   (void**)&g_pGB)))
// {
//	 MessageBox(NULL, "  DirectShow", "Error", MB_OK);
//	 return E_FAIL;
// }
// pDiSound->SetCooperativeLevel(hwnd, DSSCL_PRIORITY);
 
 
  // Load a sound to play
// pDiSoundBuf8 = LoadWAV("Music\\Test.wav");
// if(pDiSoundBuf8 != NULL) {
    // Play sound looping
//  pDiSoundBuf8->SetCurrentPosition(0);
//  pDiSoundBuf8->SetVolume(DSBVOLUME_MAX);
//  pDiSoundBuf8->Play(0,0,DSBPLAY_LOOPING);
  
   
//  pDiSoundBuf8->SetFrequency(80000);
//  }
 
// g_pGB->QueryInterface(IID_IMediaControl, (void**)&g_pMC);
// g_pGB->QueryInterface(IID_IMediaEvent, (void**)&g_pME);
// g_pGB->RenderFile(L"Music\\ .mp3", NULL);
// g_pMC->Run();

 ZeroMemory(&msg, sizeof(msg));

 while(msg.message !=WM_QUIT)
 {
	 if (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
	 {
	 TranslateMessage(&msg);
	 DispatchMessage(&msg);

//	 long Event, Param1, Param2;
// if(SUCCEEDED(g_pME->GetEvent(&Event, &Param1, &Param2, 1)))
//	 {
//		 if(Event==EC_COMPLETE)
//		 {
//			 g_pME->FreeEventParams(Event, Param1, Param2);
//			 break;
//		 }
//	 }
//	 g_pME->FreeEventParams(Event, Param1, Param2);
	 }
	 else

     Rendering3D();

 }
 CoUninitialize();
UnregisterClass("WINDOWSCLASS", hinstance);

 return (0);
}
//===============================================================================
LRESULT CALLBACK MainWinProc(HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
//===============================================================================
{
 switch(msg)
 {
 case WM_PAINT:
 // Rendering3D();
 // ValidateRect(hwnd, NULL);
 //GetVersion();
	 break;

 case WM_DESTROY:
	 {
	  DeleteDirect3D();
      PostQuitMessage(0);
	  return (0);
	 }
 case WM_KEYDOWN:
	 {
		 if(wParam==VK_ESCAPE)
		 PostQuitMessage(0);
		 return 0;
	 }
	
 }

 return (DefWindowProc(hwnd, msg, wParam, lParam));

}

//======================================================================
HRESULT Initial3D(HWND hwnd, DWORD iWidth,
				  DWORD iHeight, BOOL bFullScreen)
//======================================================================
{
 if(NULL==(pD3D=Direct3DCreate9(D3D_SDK_VERSION)))
  return E_FAIL;
 
 D3DDISPLAYMODE d3ddm;

 //   
 pD3D->GetDeviceCaps(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, &caps);
 //   ?
 if(caps.DevCaps & D3DDEVCAPS_HWTRANSFORMANDLIGHT)
 {
	 //,    vp     
	 vp=D3DCREATE_HARDWARE_VERTEXPROCESSING;
 }
 else
 {
	//,       
	 vp=D3DCREATE_SOFTWARE_VERTEXPROCESSING;
 }

// D3DPRESENT_PARAMETERS d3dpp;
 ZeroMemory(&d3dpp, sizeof(d3dpp));
 d3dpp.BackBufferWidth=iWidth;
 d3dpp.BackBufferHeight=iHeight;
 d3dpp.BackBufferCount=3;
 d3dpp.AutoDepthStencilFormat=D3DFMT_D24S8;
 d3dpp.EnableAutoDepthStencil=TRUE;

 int iRes;
 if (!bFullScreen)
	 iRes=MessageBox(hwnd, "   ?", "S c r e e n", MB_YESNO|MB_ICONQUESTION);
 else
	 iRes=IDYES;
  if(iRes==IDYES)
  {
   //   
   d3dpp.BackBufferFormat=D3DFMT_R5G6B5;
   d3dpp.SwapEffect=D3DSWAPEFFECT_FLIP;
   d3dpp.Windowed=FALSE;
   d3dpp.FullScreen_RefreshRateInHz=D3DPRESENT_RATE_DEFAULT;
   d3dpp.PresentationInterval=D3DPRESENT_INTERVAL_DEFAULT;
  }
  else
  {
   // 
   RECT wndRect;
   RECT clientRect;
   //  
   GetWindowRect(hwnd, &wndRect);
   GetClientRect(hwnd, &clientRect);
   iWidth=iWidth+(wndRect.right-wndRect.left)-
	        (clientRect.right-clientRect.left);
   iHeight=iHeight+(wndRect.bottom-wndRect.top)-
	        (clientRect.bottom-clientRect.top);
   //  
   MoveWindow(hwnd, wndRect.left, wndRect.top, iWidth, iHeight, FALSE);
   //  
   pD3D->GetAdapterDisplayMode(D3DADAPTER_DEFAULT, &d3ddm);

   d3dpp.BackBufferFormat=d3ddm.Format;
   d3dpp.SwapEffect=D3DSWAPEFFECT_DISCARD;
   d3dpp.Windowed=TRUE;
  }

  // 3D-
  if(FAILED(pD3D->CreateDevice(D3DADAPTER_DEFAULT, D3DDEVTYPE_HAL, hwnd, vp, &d3dpp, 
	    &p3Ddev)))
	return E_FAIL;

  p3Ddev->SetRenderState(D3DRS_CULLMODE, D3DCULL_NONE);
  p3Ddev->SetRenderState(D3DRS_LIGHTING, FALSE);

 return S_OK;
}

//===================================================================================
void Rendering3D()
//===================================================================================
{
 if(p3Ddev==NULL)
 return;

 HRESULT hr;
	hr=p3Ddev->TestCooperativeLevel();
	if(hr==D3DERR_DEVICELOST) return;
	if (hr==D3DERR_DEVICENOTRESET)
	{
		p3Ddev->Reset(&d3dpp);
	}


 Camera();

 p3Ddev->Clear(0, NULL, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER, D3DXCOLOR RGB(200, 100, 100), 1.0f, 0);
 

 if(FAILED(p3Ddev->BeginScene()))
 {

  if(keyb[DIK_W] & 0x80)
  {
   
  }

  if(keyb[DIK_S] & 0x80)
  {
   
  }

  if(keyb[DIK_A] & 0x80)
  {
    
  }

  if(keyb[DIK_D] & 0x80)
  {
    
  }
	//     
  R_S_T_Matrix(0.0f, 0.0f, 0.0f, 0.0f, 0.0f, 5.0f, 5.0f, 5.0f);
  RenderMeshObject(0);

  R_S_T_Matrix(0.0f, 0.0f, 0.0f, 0.0f, 0.0f, 5.0f, 5.0f, 5.0f);
  RenderMeshObject(1);

  R_S_T_Matrix(0.0f, 0.0f, 0.0f, 0.0f, 0.0f, 5.0f, 5.0f, 5.0f);
  RenderMeshObject(2);

LightPoint();

//Textout(0, "fps: %d", FPS, D3DCOLOR_XRGB(100, 200, 50));
//Textout(1, "  : %d",     iWidth,  ORANGE);
//Textout(2, "  : %d",     iHeight, ORANGE);
//Textout(6, "-------------------------------------------------", NULL, LIME);
//Textout(7, "   : %d",     iOchko, ORANGE);

 p3Ddev->EndScene();
}
// }

 p3Ddev->SetTexture(0, NULL);
 p3Ddev->Present(NULL, NULL, NULL, NULL);

 //  
// static float newTime;
// static float deltatime;
// FrameCnt++;
// newTime = GetTickCount();
// deltatime = newTime - oldTime;
// TimeElapsed += deltatime;
// if(TimeElapsed >= 1000.0f)
/// {
//  FPS = 1000 * (float)FrameCnt / TimeElapsed;
//  TimeElapsed = 0.0f;
//  FrameCnt = 0;
// }

}

//===========================================================================
HRESULT InitialInput()
//===================================================================================
{
 if(FAILED(pDI->CreateDevice(GUID_SysMouse, &pMouse, NULL)))
 {
	 MessageBox(0, "Error Input CreateDevice", "Error", 0);
	 return FALSE;
 }
 pMouse->SetDataFormat(&c_dfDIMouse);
 pMouse->SetCooperativeLevel(hwnd, DISCL_FOREGROUND|DISCL_NONEXCLUSIVE);
 pMouse->Poll();
 pMouse->Acquire();
 ZeroMemory(&dims, sizeof(DIMOUSESTATE));
 pDI->CreateDevice(GUID_SysKeyboard, &pKeyboard, NULL);
 pKeyboard->SetDataFormat(&c_dfDIKeyboard);
 pKeyboard->SetCooperativeLevel(hwnd, DISCL_FOREGROUND|DISCL_NONEXCLUSIVE);
 pKeyboard->Poll();
 pKeyboard->Acquire();

 return S_OK;
}

//=============================================================================
void Camera()
//=============================================================================
{
oldTime = GetTickCount();

pMouse->GetDeviceState(sizeof(DIMOUSESTATE), (void**)&dims);

// angleYaw +=(dims.lX/125.0f+dims.lX/250.0f+dims.lX/500.0f+dims.lX/1000.0f)/10.0f;
 anglePitch +=(dims.lY/125.0f+dims.lY/250.0f+dims.lY/500.0f+dims.lY/1000.0f)/10.0f;

// YawX = cos(angleYaw);
// YawY = sin(angleYaw);
 PitchX = -sin(anglePitch);

 if(PitchX >0)  
 {PitchD = 1.0f - PitchX;}
 else
 {PitchD = 1.0f + PitchX;}

 if(anglePitch >  1.07) anglePitch =  1.07;
 if(anglePitch < -1.07) anglePitch = -1.07;

 pKeyboard->GetDeviceState(sizeof(keyb), (void**)&keyb);
// if(keyb[DIK_W] & 0x80) {fPosX+=(0.05*YawY); fPosZ+=(0.05*YawX);}
// if(keyb[DIK_S] & 0x80) {fPosX-=(0.05*YawY); fPosZ-=(0.05*YawX);}
// if(keyb[DIK_D] & 0x80) {fPosX+=(0.05*YawX); fPosZ-=(0.05*YawY);}
// if(keyb[DIK_A] & 0x80) {fPosX-=(0.05*YawX); fPosZ+=(0.05*YawY);}

 float Center = 0.0;
 float radius = 5.0;
 float Vlook;

CameraX=0.0f;
CameraZ= 5.0f;


 D3DXMATRIX MatWorld;
 D3DXMATRIX MatCamera;
 D3DXMATRIX MatrixProjection;

 //if(MouseButton(1)==TRUE)
 
 angleYaw +=(dims.lX/125.0f+dims.lX/250.0f+dims.lX/500.0f+dims.lX/1000.0f)/10.0f;  

 YawX = cos(angleYaw);
 YawY = sin(angleYaw);

 CameraZ=Center-radius*YawX;
 CameraX=Center-radius*YawY;
 CameraY=Center-radius*PitchX;

D3DXVECTOR3 vEye(CameraX, 1.0f,  -CameraZ);//   
 D3DXVECTOR3 vAt(0.0f, 1.0f/*fPosY-anglePitch*/, 0.0f);// 
// D3DXVECTOR3 vEye(fPosX, fPosY, fPosZ);
// D3DXVECTOR3 vAt(YawY*PitchD+fPosX,fPosY-anglePitch , YawX*PitchD+fPosZ);
 D3DXVECTOR3 vUp(0.0f, 1.0f, 0.0f);// 
 
 D3DXMatrixLookAtLH(&MatCamera, &vEye, &vAt, &vUp);
 p3Ddev->SetTransform(D3DTS_VIEW, &MatCamera);
 //MatrixProjection
 D3DXMatrixPerspectiveFovLH(&MatrixProjection, D3DX_PI/4, 1.0f, 1.0f, 10000.0f);
 p3Ddev->SetTransform(D3DTS_PROJECTION, &MatrixProjection);
}

//========================================================================
void R_S_T_Matrix(float MatX, float MatY, float MatTx, float MatTy, float MatTz,
			   float Sx, float Sy, float Sz)
//========================================================================
{

	D3DXMATRIX mBallMatrix;			// 
    D3DXMATRIX mBallScale;			// 
    D3DXMATRIX mBallSpinRotationX;	//   
	 D3DXMATRIX mBallSpinRotationY;
	D3DXMATRIX mBallTranslation;	//  
    
	//  
    D3DXMatrixRotationX( &mBallSpinRotationX, MatX);
    D3DXMatrixRotationY( &mBallSpinRotationY, MatY);
	//  
    D3DXMatrixScaling( &mBallScale, Sx, Sy, Sz);	
	//  
	D3DXMatrixTranslation(&mBallTranslation, MatTx, MatTy, MatTz);
    
	//     
	mBallMatrix =	mBallSpinRotationX 
		            * mBallSpinRotationY
					* mBallScale        										
					* mBallTranslation;

	//   
    p3Ddev->SetTransform( D3DTS_WORLD, &mBallMatrix );
}

//===================================================================================
HRESULT InitialMeshObject(int mesh, LPCTSTR pFilename, LPCTSTR pSrcFile)
//===================================================================================
{
 if(FAILED(D3DXLoadMeshFromX(pFilename, D3DXMESH_SYSTEMMEM, p3Ddev, NULL, &pMeshBuffer[mesh],
	 NULL, &dwMeshNumber[mesh], &pMesh[mesh])))
	 return E_FAIL;

 D3DXMATERIAL* D3DXMeshMaterials;
 D3DXMeshMaterials=(D3DXMATERIAL *)pMeshBuffer[mesh]->GetBufferPointer();

 pMeshMaterial[mesh] = new D3DMATERIAL9[dwMeshNumber[mesh]];
 pMeshTextura[mesh] = new LPDIRECT3DTEXTURE9[dwMeshNumber[mesh]];

 for(DWORD Mi = 0; Mi < dwMeshNumber[mesh]; Mi++)
 {
  pMeshMaterial[mesh][Mi] = D3DXMeshMaterials[Mi].MatD3D;
  pMeshMaterial[mesh][Mi].Ambient = pMeshMaterial[mesh][Mi].Diffuse;

 if(FAILED(D3DXCreateTextureFromFile(p3Ddev, D3DXMeshMaterials[Mi].pTextureFilename,
	 &pMeshTextura[mesh][Mi])))
if(FAILED(D3DXCreateTextureFromFile(p3Ddev, pSrcFile,
	 &pMeshTextura[mesh][Mi])))
	 pMeshTextura[mesh][Mi] = NULL;
 }
 pMeshBuffer[mesh]->Release();
 //////////////////////////////////
 HRESULT hr = 0;

  BYTE* v = 0;

  D3DXVECTOR3 min;
  D3DXVECTOR3 max;

  pMesh[mesh]->LockVertexBuffer(D3DLOCK_READONLY, (void**)&v);

   hr = D3DXComputeBoundingBox((D3DXVECTOR3*)v, pMesh[mesh]->GetNumVertices(),
	                            D3DXGetFVFVertexSize(pMesh[mesh]->GetFVF()),
								&min, &max);

  pMesh[mesh]->UnlockVertexBuffer();

  if(FAILED(pMesh[mesh]->OptimizeInplace(D3DXMESHOPT_ATTRSORT, NULL, NULL, NULL, NULL)))
		return E_FAIL;

 //  ReleaseCOM(pMesh[50]);
  

 return S_OK;
}

//   
//=======================================================================================
void RenderMeshObject(int mesh)
//======================================================================================
{
 for (DWORD Mi = 0; Mi < dwMeshNumber[mesh]; Mi++)
 {
 // p3Ddev->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
  p3Ddev->SetMaterial(&pMeshMaterial[mesh][Mi]);
  p3Ddev->SetTexture(0, pMeshTextura[mesh][Mi]);
//  p3Ddev->SetRenderState(D3DRS_ALPHABLENDENABLE, TRUE);
  pMesh[mesh]->DrawSubset(Mi);
 // p3Ddev->SetRenderState(D3DRS_ALPHABLENDENABLE, FALSE);
 }
}

 //============================================================================
void LightPoint()//  
//============================================================================
{
  D3DMATERIAL9 material;
  D3DLIGHT9 light;

  ZeroMemory(&material, sizeof(D3DMATERIAL9));
  material.Diffuse=D3DXCOLOR(1.0f, 1.0f, 1.0f, 1.0f);
  material.Ambient=D3DXCOLOR(1.0f, 1.0f, 0.0f, 0.0f);
  material.Specular=D3DXCOLOR(1.0f, 0.0f, 0.0f, 1.0f);
//  
  p3Ddev->SetMaterial(&material);

  ZeroMemory(&light, sizeof(D3DLIGHT9));
  light.Type=D3DLIGHT_POINT; //  
  light.Diffuse=D3DXCOLOR(1.0f, 1.0f, 1.0f, 1.0f); //   
  light.Ambient=D3DXCOLOR(1.0f, 1.0f, 1.0f, 1.0f);
  light.Position=D3DXVECTOR3(2.0f, 25.0f, -25.0f); //   (  )
  light.Attenuation0=1.0f; //   
  light.Range=100; //    

  p3Ddev->SetRenderState(D3DRS_LIGHTING, TRUE);
  p3Ddev->SetLight(0, &light);
  p3Ddev->LightEnable(0, TRUE);
 // p3Ddev->SetRenderState( D3DRS_AMBIENT, 0x00202020 );


 // p3Ddev->SetRenderState(D3DRS_LIGHTING, FALSE);
}

//=====================================================================
void DeleteDirect3D()
//=====================================================================
{
 if(pD3D !=NULL)
	 pD3D->Release();
     pD3D = NULL;

 if(p3Ddev !=NULL)
	 p3Ddev->Release();
     p3Ddev = NULL;
}


